SDL_test_crc32.c File Reference
`#include "SDL_config.h"`
`#include "SDL_test.h"`
Include dependency graph for SDL_test_crc32.c:

Go to the source code of this file.

## Functions

int | SDLTest_Crc32Init (SDLTest_Crc32Context *crcContext)
| Initialize the CRC context. More...
int | SDLTest_Crc32Calc (SDLTest_Crc32Context *crcContext, CrcUint8 *inBuf, CrcUint32 inLen, CrcUint32 *crc32)
| calculate a crc32 from a data block More...
int | SDLTest_Crc32CalcStart (SDLTest_Crc32Context *crcContext, CrcUint32 *crc32)
int | SDLTest_Crc32CalcEnd (SDLTest_Crc32Context *crcContext, CrcUint32 *crc32)
int | SDLTest_Crc32CalcBuffer (SDLTest_Crc32Context *crcContext, CrcUint8 *inBuf, CrcUint32 inLen, CrcUint32 *crc32)
int | SDLTest_Crc32Done (SDLTest_Crc32Context *crcContext)
| clean up CRC context More...

## Function Documentation

## SDLTest_Crc32Calc()

int SDLTest_Crc32Calc | ( | SDLTest_Crc32Context * | crcContext,
|  | CrcUint8 * | inBuf,
|  | CrcUint32 | inLen,
|  | CrcUint32 * | crc32
| ) |  |

calculate a crc32 from a data block

Parameters

  crcContext | pointer to context variable
  inBuf | input buffer to checksum
  inLen | length of input buffer
  crc32 | pointer to Uint32 to store the final CRC into

Returns
  0 for OK, -1 on error

Definition at line 72 of file SDL_test_crc32.c.

References SDLTest_Crc32CalcBuffer(), SDLTest_Crc32CalcEnd(), and SDLTest_Crc32CalcStart().

Referenced by get_allocation_bucket().

{
if (SDLTest_Crc32CalcStart(crcContext,crc32)) {
return -1;
}
if (SDLTest_Crc32CalcBuffer(crcContext, inBuf, inLen, crc32)) {
return -1;
}
if (SDLTest_Crc32CalcEnd(crcContext, crc32)) {
return -1;
}
return 0;
}
SDLTest_Crc32CalcEnd
int SDLTest_Crc32CalcEnd(SDLTest_Crc32Context *crcContext, CrcUint32 *crc32)
Definition: SDL_test_crc32.c:109
SDLTest_Crc32CalcBuffer
int SDLTest_Crc32CalcBuffer(SDLTest_Crc32Context *crcContext, CrcUint8 *inBuf, CrcUint32 inLen, CrcUint32 *crc32)
Definition: SDL_test_crc32.c:127
SDLTest_Crc32CalcStart
int SDLTest_Crc32CalcStart(SDLTest_Crc32Context *crcContext, CrcUint32 *crc32)
Definition: SDL_test_crc32.c:91

## SDLTest_Crc32CalcBuffer()

int SDLTest_Crc32CalcBuffer | ( | SDLTest_Crc32Context * | crcContext,
|  | CrcUint8 * | inBuf,
|  | CrcUint32 | inLen,
|  | CrcUint32 * | crc32
| ) |  |

Definition at line 127 of file SDL_test_crc32.c.

References SDLTest_Crc32Context::crc32_table, CrcUint32, CrcUint8, and NULL.

Referenced by SDLTest_Crc32Calc().

{
CrcUint8 *p;
register CrcUint32 crc;
if (crcContext==NULL) {
*crc32=0;
return -1;
}
if (inBuf==NULL) {
return -1;
}
/*
* Calculate CRC from data
*/
crc = *crc32;
for (p = inBuf; inLen > 0; ++p, --inLen) {
#ifdef ORIGINAL_METHOD
crc = (crc << 8) ^ crcContext->crc32_table[(crc >> 24) ^ *p];
#else
crc = ((crc >> 8) & 0x00FFFFFF) ^ crcContext->crc32_table[ (crc ^ *p) & 0xFF ];
#endif
}
*crc32 = crc;
return 0;
}
p
GLfloat GLfloat p
Definition: SDL_opengl_glext.h:11090
SDLTest_Crc32Context::crc32_table
CrcUint32 crc32_table[256]
Definition: SDL_test_crc32.h:67
NULL
#define NULL
Definition: begin_code.h:164
CrcUint32
#define CrcUint32
Definition: SDL_test_crc32.h:51
CrcUint8
#define CrcUint8
Definition: SDL_test_crc32.h:54

## SDLTest_Crc32CalcEnd()

int SDLTest_Crc32CalcEnd | ( | SDLTest_Crc32Context * | crcContext,
|  | CrcUint32 * | crc32
| ) |  |

Definition at line 109 of file SDL_test_crc32.c.

References NULL.

Referenced by SDLTest_Crc32Calc().

{
/* Sanity check pointers */
if (crcContext==NULL) {
*crc32=0;
return -1;
}
/*
* Return complement, per CRC-32 spec
*/
*crc32 = (~(*crc32));
return 0;
}
NULL
#define NULL
Definition: begin_code.h:164

## SDLTest_Crc32CalcStart()

int SDLTest_Crc32CalcStart | ( | SDLTest_Crc32Context * | crcContext,
|  | CrcUint32 * | crc32
| ) |  |

Definition at line 91 of file SDL_test_crc32.c.

References NULL.

Referenced by SDLTest_Crc32Calc().

{
/* Sanity check pointers */
if (crcContext==NULL) {
*crc32=0;
return -1;
}
/*
* Preload shift register, per CRC-32 spec
*/
*crc32 = 0xffffffff;
return 0;
}
NULL
#define NULL
Definition: begin_code.h:164

## SDLTest_Crc32Done()

int SDLTest_Crc32Done | ( | SDLTest_Crc32Context * | crcContext | ) |

clean up CRC context

Parameters

  crcContext | pointer to context variable

Returns
  0 for OK, -1 on error

Definition at line 157 of file SDL_test_crc32.c.

References NULL.

{
if (crcContext==NULL) {
return -1;
}
return 0;
}
NULL
#define NULL
Definition: begin_code.h:164

## SDLTest_Crc32Init()

int SDLTest_Crc32Init | ( | SDLTest_Crc32Context * | crcContext | ) |

Initialize the CRC context.

Note: The function initializes the crc table required for all crc calculations.

Parameters

  crcContext | pointer to context variable

Returns
  0 for OK, -1 on error

Definition at line 34 of file SDL_test_crc32.c.

References CRC32_POLY, SDLTest_Crc32Context::crc32_table, CrcUint32, i, j, and NULL.

Referenced by SDLTest_TrackAllocations().

{
int i,j;
CrcUint32 c;
/* Sanity check context pointer */
if (crcContext==NULL) {
return -1;
}
/*
* Build auxiliary table for parallel byte-at-a-time CRC-32
*/
#ifdef ORIGINAL_METHOD
for (i = 0; i < 256; ++i) {
for (c = i << 24, j = 8; j > 0; --j) {
c = c & 0x80000000 ? (c << 1) ^ CRC32_POLY : (c << 1);
}
crcContext->crc32_table[i] = c;
}
#else
for (i=0; i<256; i++) {
c = i;
for (j=8; j>0; j--) {
if (c & 1) {
c = (c >> 1) ^ CRC32_POLY;
} else {
c >>= 1;
}
}
crcContext->crc32_table[i] = c;
}
#endif
return 0;
}
CRC32_POLY
#define CRC32_POLY
Definition: SDL_test_crc32.h:60
SDLTest_Crc32Context::crc32_table
CrcUint32 crc32_table[256]
Definition: SDL_test_crc32.h:67
j
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int int in j)
Definition: SDL_x11sym.h:50
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
NULL
#define NULL
Definition: begin_code.h:164
CrcUint32
#define CrcUint32
Definition: SDL_test_crc32.h:51